var electoralcollege = {
	toolTipText: "No election to follow.",
	isError: "0",

	// Initialize the extension
	
	startup: function()
	{
		this.refreshInformation();
		window.setInterval(this.refreshInformation, 60*60*1000);
	},
	
	// Clean up after ourselves and save the prefs
	
	shutdown: function()
	{

	},
	
	go_to_site: function() {
		var myurl = "http://www.electoral-vote.com/";
		var tab = getBrowser().addTab( myurl );
		getBrowser().selectedTab = tab;
	},
	onStatusBarButtonCommand: function(event) {
		switch(event.button) {
			case 0:
			// Left click
			this.go_to_site();
			break;
			case 1:
			// Middle click
			this.refreshInformation();
			break;
			//case 2:
			// Right click
			//alert("right click");
			//break;
		}


	},
	// Refresh the information
	getToolTip: function() {
		this.populateToolTip();
	},
	populateToolTip: function() {
		var d = document.getElementById('electoralcollegetip');
		// Build the tooltip string
		var parent = d;
		//remove all labels
		while (parent.hasChildNodes())
			parent.removeChild(parent.lastChild);

		if(electoralcollege.isError) {
			item = document.createElement("label");
			item.setAttribute("value", "Unable to connect at this time.");
			item.setAttribute("style", "font-size: 10px; margin: 2px 4px 2px 4px;");
			parent.appendChild(item);

		} else {

			item = document.createElement("label");
			item.setAttribute("value", electoralcollege.message_1);
			item.setAttribute("style", "margin: 1px;font-size:10pt;");
			parent.appendChild(item);

			item = document.createElement("label");
			item.setAttribute("value", electoralcollege.message_2);
			item.setAttribute("style", "margin: 1px;font-size:10pt;");
			parent.appendChild(item);

			item = document.createElement("label");
			item.setAttribute("value", electoralcollege.message_3);
			item.setAttribute("style", "margin: 1px;font-weight:bold;font-size:10pt;");
			parent.appendChild(item);

			parent.setAttribute("align", "left");
			parent.setAttribute("hidden", "false");

		}
	},
	refreshInformation: function()
	{
		var httpRequest = null;
		var stringsBundle = null;
		
		// Get a reference to the strings bundle
		
		stringsBundle = document.getElementById("string-bundles");

		// Get the strings
		var electoralcollegeerror = stringsBundle.getString('electoralcollegeerror') + " ";
		
		// Because we may be called as a callback, we can't rely on
		// "this" referring to the right object, so we need to get our
		// own preferences instance here.
		
		var fullUrl = "http://www.electoral-vote.com/evp2008/Info/statusbar.xml";
		
		function infoReceived()
		{
			var samplePanel = document.getElementById('electoralcollege');
			var output = httpRequest.responseXML;
			var root = output.getElementsByTagName('root').item(0);

			if (root.childNodes.length > 1)
			{
				electoralcollege.isError = 0;

				var panel_text = String(root.getElementsByTagName('panel_text')[0].firstChild.data);
				panel_text = panel_text.replace(/\W*$/, "");
				panel_text = panel_text.replace(/^\s*|\s*$/g,'');

				var panel_color = String(root.getElementsByTagName('panel_color')[0].firstChild.data);
				panel_color = panel_color.replace(/\W*$/, "");
				panel_color = panel_color.replace(/^\s*|\s*$/g,'');

				var line1 = String(root.getElementsByTagName('line1')[0].firstChild.data);
				line1 = line1.replace(/^\s*|\s*$/g,'');
				var line2 = String(root.getElementsByTagName('line2')[0].firstChild.data);
				line2 = line2.replace(/^\s*|\s*$/g,'');
				var line3 = String(root.getElementsByTagName('line3')[0].firstChild.data);
				line3 = line3.replace(/^\s*|\s*$/g,'');

				samplePanel.setAttribute("style", "color: "+panel_color+";");
				samplePanel.label = panel_text;

				electoralcollege.message_1 = line1;
				electoralcollege.message_2 = line2;
				electoralcollege.message_3 = line3;


			} else {
				samplePanel.label = electoralcollegeerror;
				electoralcollege.isError = 1;
			}

		}

  		httpRequest = new XMLHttpRequest();
		httpRequest.open("GET", fullUrl, true);
		httpRequest.onload = infoReceived;
		httpRequest.send(null);
	}
}


// Install load and unload handlers
window.addEventListener("load", function(e) { electoralcollege.startup(); }, false);
window.addEventListener("unload", function(e) { electoralcollege.shutdown(); }, false);